Graphics 640,480,16,2

HidePointer

wallpaper=LoadImage("wallpaper.png")

loupe=CreateImage(150,210) : MaskImage loupe,255,0,255
Global loupe_1=LoadImage("loupe.png") : MaskImage loupe_1,255,0,200

zoom=2

SetBuffer BackBuffer()
Repeat
Cls

DrawImage wallpaper,0,0

Loupe(loupe,MouseX()-75,MouseY()-105,60,60,zoom)

SetBuffer ImageBuffer(loupe)
DrawImage loupe_1,0,0
SetBuffer BackBuffer()

DrawImage loupe,MouseX()-75,MouseY()-105

If MouseHit(1) Then zoom=zoom+1
If MouseHit(2) And zoom>1 Then zoom=zoom-1

Flip
Until KeyDown(1)

WaitKey
End





Function Loupe(lpimg,lpx,lpy,lmx,lmy,zoom=2)
	If zoom<1 Then RuntimeError(Chr(34)+"zoom"+Chr(34)+" must be greater then 0.")
	
	Local zmbf=GraphicsBuffer()
	Local loupe_width=ImageWidth(lpimg)-1
	Local loupe_height=ImageHeight(lpimg)-1
	
	LockBuffer zmbf
	LockBuffer ImageBuffer(lpimg)
	For y=0 To loupe_height/zoom
		For x=0 To loupe_width/zoom
			rgbpx=x+lpx+lmx/zoom*(zoom-1)
			rgbpy=y+lpy+lmy/zoom*(zoom-1)
			
			If rgbpx>=0 And rgbpx<GraphicsWidth() And rgbpy>=0 And rgbpy<GraphicsHeight() Then
				rgb=ReadPixelFast(rgbpx,rgbpy,zmbf)
			Else
				rgb=$FF000000
			EndIf
			For ty=0 To zoom-1
				For tx=0 To zoom-1
					rgbpx=x*zoom+tx
					rgbpy=y*zoom+ty
					If rgbpx<loupe_width And rgbpy<loupe_height Then
						WritePixelFast(rgbpx,rgbpy,rgb,ImageBuffer(lpimg))
					EndIf
				Next
			Next
		Next
	Next
	UnlockBuffer zmbf
	UnlockBuffer ImageBuffer(lpimg)
End Function

